Package com.saxonica.ee.trans

## Class PrincipalStylesheetModuleEE

- java.lang.Object
- - net.sf.saxon.style.StylesheetModule
  - - net.sf.saxon.style.PrincipalStylesheetModule
    - - com.saxonica.ee.trans.PrincipalStylesheetModuleEE

- All Implemented Interfaces:
    `GlobalVariableManager`

      public class PrincipalStylesheetModuleEE
      extends PrincipalStylesheetModule

  This version of the StylesheetPackage class represents a "real" package, that is one with an xsl:package element, which potentially uses other packages and overrides selected components in those packages.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.style.StylesheetModule

      `topLevel`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PrincipalStylesheetModuleEE​(XSLPackage node)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addGlobalVariable​(GlobalVariable variable)` | Add a global variable to the collection
    `protected void` | `checkStreamability​(AttributeSet aSet)` | Check the streamability of an attribute set declared within this stylesheet module.
    `GlobalVariable` | `getEquivalentVariable​(Expression select)` | Get an existing global variable whose initializer is a given expression, if there is one.
    `protected void` | `importSchemata()` | Process import-schema declarations

    - ### Methods inherited from class net.sf.saxon.style.PrincipalStylesheetModule

      `addFixupAction, addGlobalVariable, addImportedSchema, addNamespaceAlias, adjustExposedVisibility, checkAcceptableModeForPackage, combineAttributeSets, compile, compileError, compileError, complete, declareXQueryFunction, fixup, gatherOutputProperties, getAccumulatorManager, getAttributeSetDeclarations, getAttributeSets, getCharacterMap, getCharacterMapIndex, getComponent, getDecimalFormatManager, getGlobalVariableBinding, getImportedSchemaTable, getKeyManager, getNamedTemplate, getNamespaceAlias, getPrincipalStylesheetModule, getRuleManager, getSlotManager, getStylesheetDocument, getStylesheetPackage, getTypeAliasManager, hasNamespaceAliases, indexAttributeSet, indexFunction, indexMode, indexNamedTemplate, indexVariableDeclaration, isAliasResultNamespace, isDeclaredModes, isImportedSchema, optimizeTopLevel, preprocess, processAllAttributes, putStylesheetDocument, setAccumulatorManager, setNeedsDynamicOutputProperties, spliceUsePackages`

    - ### Methods inherited from class net.sf.saxon.style.StylesheetModule

      `getAssociatedStylesheet, getConfiguration, getImporter, getInputTypeAnnotations, getMinImportPrecedence, getPrecedence, getRootElement, getStylesheetElement, loadStylesheet, loadStylesheetModule, setImporter, setInputTypeAnnotations, setMinImportPrecedence, setWasIncluded, spliceIncludes`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PrincipalStylesheetModuleEE

          public PrincipalStylesheetModuleEE​(XSLPackage node)
                                      throws XPathException

      Throws:
        `XPathException`

  - ### Method Detail

    - #### importSchemata

          protected void importSchemata()
                                 throws XPathException

      Process import-schema declarations
      Overrides:
        `importSchemata` in class `PrincipalStylesheetModule`
      Throws:
        `XPathException` - if errors are detected

    - #### checkStreamability

          protected void checkStreamability​(AttributeSet aSet)
                                     throws XPathException

      Check the streamability of an attribute set declared within this stylesheet module. (Null implementation for Saxon-HE).
      Overrides:
        `checkStreamability` in class `PrincipalStylesheetModule`
      Parameters:
        `aSet` - the attribute set to be checked (the method is called only if the attribute set is declared streamable)
      Throws:
        `XPathException` - if the streamability rules are not satisifed

    - #### addGlobalVariable

          public void addGlobalVariable​(GlobalVariable variable)

      Description copied from interface: `GlobalVariableManager`
      Add a global variable to the collection
      Specified by:
        `addGlobalVariable` in interface `GlobalVariableManager`
      Overrides:
        `addGlobalVariable` in class `PrincipalStylesheetModule`
      Parameters:
        `variable` - the variable to be added

    - #### getEquivalentVariable

          public GlobalVariable getEquivalentVariable​(Expression select)

      Description copied from interface: `GlobalVariableManager`
      Get an existing global variable whose initializer is a given expression, if there is one. Note that this depends on the logic for detecting equivalence of expressions, which is necessarily approximate. Expressions with dependencies on the static context should never be considered equivalent. If no equivalent global variable is found, return null. An implementation can always return null if it wants to avoid a lengthy search.
      Specified by:
        `getEquivalentVariable` in interface `GlobalVariableManager`
      Overrides:
        `getEquivalentVariable` in class `PrincipalStylesheetModule`
      Returns:
        an existing global variable with the same select expression, if one can be found; otherwise null.